Unit de22e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE20E_p, UTDE11_p;

procedure de22e(F :Proc_FE_DE; M :Integer; XN :Extended;
                var YN :Array of Extended; XK :Extended; HMIN :Extended;
                EPS :Extended; IORDER :Integer; IU :Integer;
                var H :Extended; var Y :Array of Extended;
                var YPM :Array of Extended; var DELTY :Array of Extended;
                var RAB :Array of Extended; var IERR :Integer);

implementation

procedure de22e(F :Proc_FE_DE; M :Integer; XN :Extended;
                var YN :Array of Extended; XK :Extended; HMIN :Extended;
                EPS :Extended; IORDER :Integer; IU :Integer;
                var H :Extended; var Y :Array of Extended;
                var YPM :Array of Extended; var DELTY :Array of Extended;
                var RAB :Array of Extended; var IERR :Integer);
var
I :Integer;
X,HS,H1 :Extended;
BUL :Boolean;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
IERR := 0;
for I:=1 to M do
 begin
_1:
  Y[I-1] := YN[I-1];
 end;
if ( XN = XK ) 
 then goto _9;
X := XN;
H := Sign(H,XK-XN);
BUL := False;
if ( IU <> 3 ) 
 then goto _3;
for I:=1 to M do
 begin
_2:
  YPM[I-1] := 1.e0;
 end;
goto _5;
_3:
for I:=1 to M do
 begin
_4:
  YPM[I-1] := YN[I-1];
 end;
_5:
I := 0;
_6:
if ( not BUL ) 
 then goto _7;
H := HS;
goto _9;
_7:
H1 := XK-X;
if ( Abs(H1) > Abs(H) ) 
 then goto _8;
HS := H;
BUL := True;
H := H1;
_8:
DE20E(F,M,IORDER,IU,I,HMIN,EPS,X,Y,H,BUL,YPM,DELTY,RAB,IERR);
if ( IERR = 1 ) or ( IERR = 0 ) 
 then goto _6;
_9:
if ( IERR = 0 ) 
 then goto _10;
UTDE11(IERR,22);
_10:
end;

end.
